/*************************************************************************
 *
 *  $RCSfile: spinfld.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: hr $ $Date: 2000/12/07 13:37:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SPINFLD_HXX
#define _SV_SPINFLD_HXX

#ifndef _SV_SV_H
#include <vcl/sv.h>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif

// -------------
// - SpinField -
// -------------

class SpinField : public Edit
{
protected:
	Edit*			mpEdit;
	AutoTimer		maRepeatTimer;
	Rectangle		maUpperRect;
	Rectangle		maLowerRect;
	Rectangle		maDropDownRect; // noch nicht angebunden...
	Link			maUpHdlLink;
	Link			maDownHdlLink;
	Link			maFirstHdlLink;
	Link			maLastHdlLink;
	BOOL			mbRepeat:1,
					mbSpin:1,
					mbInitialUp:1,
					mbInitialDown:1,
					mbNoSelect:1,
					mbUpperIn:1,
					mbLowerIn:1,
					mbInDropDown:1;

#if 0 // _SOLAR__PRIVATE
	void			ImplInit( Window* pParent, WinBits nStyle );

#ifdef _SV_SPINFLD_CXX
private:
					DECL_LINK( ImplTimeout, Timer* );
	void			ImplInitData();
	void			ImplCalcButtonAreas( OutputDevice* pDev, const Size& rOutSz, Rectangle& rDDArea, Rectangle& rSpinUpArea, Rectangle& rSpinDownArea );
#endif
#endif

protected:
					SpinField( WindowType nTyp );

	virtual long	Notify( NotifyEvent& rNEvt );
	virtual void	Command( const CommandEvent& rCEvt );

	void			EndDropDown();

public:
					SpinField( Window* pParent, WinBits nWinStyle = 0 );
					SpinField( Window* pParent, const ResId& rResId );
					~SpinField();

	virtual BOOL	ShowDropDown( BOOL bShow );

	virtual void	Up();
	virtual void	Down();
	virtual void	First();
	virtual void	Last();

	virtual void	MouseButtonDown( const MouseEvent& rMEvt );
	virtual void	MouseButtonUp( const MouseEvent& rMEvt );
	virtual void	MouseMove( const MouseEvent& rMEvt );
	virtual void	Paint( const Rectangle& rRect );
	virtual void	Draw( OutputDevice* pDev, const Point& rPos, const Size& rSize, ULONG nFlags );
	virtual void	Resize();
	virtual void	StateChanged( StateChangedType nType );
	virtual void	DataChanged( const DataChangedEvent& rDCEvt );

	void			SetUpHdl( const Link& rLink ) { maUpHdlLink = rLink; }
	const Link& 	GetUpHdl() const { return maUpHdlLink; }
	void			SetDownHdl( const Link& rLink ) { maDownHdlLink = rLink; }
	const Link& 	GetDownHdl() const { return maDownHdlLink; }
	void			SetFirstHdl( const Link& rLink ) { maFirstHdlLink = rLink; }
	const Link& 	GetFirstHdl() const { return maFirstHdlLink; }
	void			SetLastHdl( const Link& rLink ) { maLastHdlLink = rLink; }
	const Link& 	GetLastHdl() const { return maLastHdlLink; }

	Size			CalcMinimumSize() const;
	Size			CalcSize( USHORT nChars ) const;
	USHORT			GetMaxVisChars() const;
};

#endif // _SV_SPINFLD_HXX
